--################################################################
-- written by CrisOHara
-- Version 2
-- 25.04.2023
-- This software is free
--
-- The script is developed for x9lite-S openTx 2.3.11 (but likely to run on some other radio)
-- Cause some of the used values depend on "magic" numbers it may be nessesary to adapt for other radios
--
-- this example script reads the mixers to mix Trainer source an stick source 
-- and writes a new script that can run on an other model to use the same setting for these channels
--
--   CH25  = input student aileron
--   CH26  = input student elevator
--   CH27  = input student throttle
--   CH28  = input student ruder
--
-- no warranty: script is to be used on your own risk
--
--######################################################################


-- ############################# init function ##################
-- global variables
local errorOnIndex = 0;
local indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML

-- function
local function stuRad_init()

--##### defining of Indexes for LS01, TR1, CH01, Max ### depends on radio Type ### x9Lite = 36

	chunk, err = loadScript("/SCRIPTS/TOOLS/trainer/indLib.lua");
	if err then
	   errorOnIndex = 1;
	   return;
	   end;
        local script=chunk();
        indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML = script.init();



--#####  create mixer for Trainer (Ch25, CH26, CH27, CH28) ########################

local mixerData = { name, source, weight, offset, switch, multiplex, curveType, curveValue, flightModes, carryTrim, mixWarn, delayUp, delayDown, speedUp, speedDown}
local text = " ";

-- ######  Reading students input mixers 25 to 28 weight, offset and channelorder ###################

         my_file = io.open("/SCRIPTS/TOOLS/stuRadio/radio.lua","w");
         io.write (my_file, "local function radioDef_init();\n\n");

         for channelIndex = 24, 27 do 
             mixerData = model.getMix(channelIndex, 0);
             text = "  while (model.getMixesCount(" .. channelIndex .. ") > 0) do model.deleteMix(" .. channelIndex .. ", 0) end;\n"
             io.write (my_file, text);
	     text = "  mixerData = {name=\""    .. mixerData.name .. "\"" ..
                               ", source="    .. mixerData.source .. 
                               ", weight="    .. mixerData.weight ..
                               ", offset="    .. mixerData.offset ..
                               ", switch="    .. mixerData.switch ..
                               ", multiplex=" .. mixerData.multiplex .. "\n" ..
                               "    , curveType=0, curveValue=0, flightModes=512, carryTrim=0" ..
                               ", mixWarn=0, delayUp=0, delayDown=0, speedUp=0, speedDown=0};\n"
             io.write (my_file, text);
	     text = "  model.insertMix(" .. channelIndex .. ", 0, mixerData);\n\n"
             io.write (my_file, text);
           end

         io.write (my_file, "  return\n  end\n\n");
	 io.write (my_file, "local function radioDef_run(event)\n  lcd.clear();\n");
         io.write (my_file, "  if lineSizeMID == nil then lineSizeMID = 17; lineSizeSML = 9; end\n");
         io.write (my_file, "  lcd.drawText (0, 0,\"Student Mixers\", MIDSIZE);\n");
         io.write (my_file, "  lcd.drawText (0, lineSizeMID,\"settings recalled\", MIDSIZE);\n");
         io.write (my_file, "  lcd.drawText (0, 2*lineSizeMID,\"from script \", MIDSIZE);\n");
         io.write (my_file, "  lcd.drawText (0, 3*lineSizeMID,\"/stuRadio/radio\", MIDSIZE);\n");
         io.write (my_file, "  return 0;\n");
         io.write (my_file, "end\n\n");
         io.write (my_file, "return { init=radioDef_init, run=radioDef_run };\n");
         io.write (my_file, "\n");

         io.close (my_file);

end


-- ############################### run function #####################
local function stuRad_run(event)
	lcd.clear();

	if lineSizeMID == nil then lineSizeMID = 17; lineSizeSML = 9; end
	lcd.drawText (0, 0,"Student Mixers", MIDSIZE);
	lcd.drawText (0, lineSizeMID,"settings saved", MIDSIZE);
	lcd.drawText (0, 2*lineSizeMID,"to script ", MIDSIZE);
	lcd.drawText (0, 3*lineSizeMID,"/stuRadio/radio", MIDSIZE);
	return 0;
end

return { init=stuRad_init, run=stuRad_run };

