--################################################################
-- written by CrisOHara
-- Version 1
-- 9. June 2023
-- This software is free
--
-- The script is developed for x9lite-S openTx 2.3.15 (but likely to run on some other radio)
-- Cause some of the used values depend on "magic" numbers it may be nessesary to adapt for other radios
-- The hardware dependency is base on the fact that different type of radios do have a different amount of switches.
-- Also different software version may have an effect.
-- So please check on companion first (or at least use a copy of an existing model)
--
-- Script can be used as telemetry script in a telemetry view (but has to run only once so it should be removed after first run)
--   or with execute when selected from the file menu direct from sdcard (that's what I prefer)
-- Be aware that you have to select to model as active model first.--
--
--
--
-- no warranty: script is to be used on your own risk
--
--######################################################################

local loop_count = 1;


-- ############################### run function #####################
local function buddy_run(event)


     if (loop_count == 1) then
	 chunk, err = loadScript("/SCRIPTS/TOOLS/trainer/1LsBu5.lua");
	 if err then
	    return 1;
	    end;
         local script = chunk();
         err = script.init();
         loop_count = 2;     
       end

     if (loop_count == 2) then
	 chunk, err = loadScript("/SCRIPTS/TOOLS/trainer/2CaMi5.lua");
	 if err then
	    return 2;
	    end;
         local script = chunk();
         err = script.init();
         loop_count = 3;     
       end

     if (loop_count == 3) then
	 chunk, err = loadScript("/SCRIPTS/TOOLS/trainer/3InBud.lua");
	 if err then
	    return 3;
	    end;
         local script = chunk();
         err = script.init();
         loop_count = 4; 
       end

     if (loop_count == 4) then
          lcd.clear();
          lcd.drawText (0, 0, "Buddy Defs done", MIDSIZE);
          lcd.drawText (0, 26,"swap 3 sticks", MIDSIZE);      
          lcd.drawText (0, 52,"swap trottle", MIDSIZE);
       end

return 0;
end

return { run=buddy_run };